;Copyright 2009 Konstantinos Asimakis
;Do whatever you want as long as you keep this copyright and of course don't blame the authors.
#AutoIt3Wrapper_Icon="Marvin.ico"
Opt("TrayAutoPause",0)
TraySetIcon(@AutoItExe)
Dim $windows[1]=[-666]
Dim $isontop[1]=[-666]
$transparency=0

If Not HotKeySet("#!t","SetOnTop") Then
	MsgBox(16,"OnTop","Cannot enable the hotkey!")
	Exit
EndIf
If Not HotKeySet("#!y","ToggleTransparency") Then
	MsgBox(16,"OnTop","Cannot enable the hotkey!")
	Exit
EndIf

TraySetToolTip("OnTop" & @CRLF & "Win+Alt+T toggles always-on-top property of active window." & @CRLF & "Win+Alt+Y cycles through transparency levels.")
TrayTip("OnTop","OnTop version 1.0 by Tritonio and DimBiC is active." & @CRLF & "Win+Alt+T toggles always-on-top property of active window." & @CRLF & "Win+Alt+Y cycles through transparency levels for inactive always-on-top windows.",15,1)

While 1
	sleep(100)
	For $j=1 To UBound($windows)-1
		If $isontop[$j] Then
			If WinExists($windows[$j]) Then
				If WinActive($windows[$j]) Then
					WinSetTrans($windows[$j],"",255)
				Else
					WinSetTrans($windows[$j],"",255-$transparency/100*255)
				EndIf
			EndIf
		EndIf
	Next
WEnd

Func ToggleTransparency()
	$transparency=Mod($transparency+10,100)
		TrayTip("OnTop","Transparency for inactive always-on-top windows set to " & $transparency & "%.",2,1)
EndFunc

Func SetOnTop()
	$hwnd=WinGetHandle("[ACTIVE]")
	$title=WinGetTitle($hwnd)
	$placeintable=-1
	For $i=0 to UBound($windows)-1
		If $windows[$i]==$hwnd Then
			$placeintable=$i
			ExitLoop
		EndIf
	Next
	If $placeintable==-1 Then
		ReDim $windows[UBound($windows)+1]
		ReDim $isontop[UBound($isontop)+1]
		$windows[UBound($windows)-1]=$hwnd
		$isontop[UBound($isontop)-1]=0
		$placeintable=UBound($windows)-1
	EndIf
	$isontop[$placeintable]=1-$isontop[$placeintable]
	WinSetOnTop($hwnd,"",$isontop[$placeintable])
	If $isontop[$placeintable] Then
		TraySetToolTip("OnTop - Last window put on top: " & $title)
		TrayTip("OnTop","Put " & $title & " on top.",5,1)
	Else
		TraySetToolTip("OnTop - Last window removed from top: " & $title)
		TrayTip("OnTop","Removed " & $title & " from top.",5,1)
	EndIf
EndFunc

Func OnAutoItExit()
	For $j=1 To UBound($windows)-1
		If $isontop[$j] Then
			If WinExists($windows[$j]) Then
				WinSetOnTop($windows[$j],"",0)
				WinSetTrans($windows[$j],"",255)
			EndIf
		EndIf
	Next
EndFunc